#version 300 es

precision highp float;

in vec2 v_TexCoord;

uniform sampler2D u_SrcMask;
uniform sampler2D u_DstMask;

layout(location = 0) out vec4 o_FragColor;

void main() {
    vec2 src = texture(u_SrcMask, v_TexCoord).rg;
    float dst = texture(u_DstMask, v_TexCoord).r;
    float res = 0.0;

    if (abs(src.g - 1.0) < 0.0001 || (abs(src.r - 1.0) < 0.0001)) {
        res = dst;
    } else {
        if (abs(src.r - 0.0) < 0.0001 || abs(dst - 0.0) < 0.0001) {
            res == 0.0;
        } else if (abs(dst - 1.0) < 0.0001) {
            res = src.r;
        } else {
//            src = 1.0 - src;
//            dst = 1.0 - dst;
            res = (src.r  + dst * (1.0 - src.r));
        }
    }

    o_FragColor = vec4(res, 0.0, 0.0, 1.0);
}
